CLEAR
? "demo1"
DO demo1
? "demo2"
DO demo2
DO demo_tarif
DO demo_tarif_2
? "fin"
?
?
?
?
?
?

PROCEDURE demo1
 LOCAL locollection, lnindice
 
 * on peuple une collection avec des valeurs sans clef
 locollection = CREATEOBJECT("collection")
 locollection.add(1)
 locollection.add(2)
 locollection.add(3)
 locollection.add(4)
 * en fait on vient de crer un tableau unidimensionnel avec 4 valeurs dedans
 * on imprime le contenu dans l'ordre croissant puis dans l'ordre dcroissant
 * en utilisant les syntaxes possibles
 locollection.keysort = 0 && index ascendant
 ? "ordre ascendant"
 FOR EACH value IN locollection
   ? value
 NEXT
 locollection.keysort = 1 && index descendant
 ? "ordre descendant"
 FOR EACH value IN locollection
   ? value
 NEXT
 * avec un indice selon 2 syntaxe
 ? "avec un indice selon les 2 syntaxes possibles"
 FOR m.lnindice = 1 TO m.locollection.count
  ? TRANSFORM( m.locollection( m.lnindice)) + " "+ ;
   TRANSFORM(m.locollection.item( m.lnindice))
 NEXT
 ? "on supprime le 3me lment et on reimprime "
 locollection.remove(3)
 locollection.keysort = 0 && index ascendant
 FOR EACH value IN locollection
   ? value
 NEXT
 ? "on ne peut pas insrer un lment dans la collection "
 ? "car elle n'est pas indexe"
ENDPROC && demo1

PROCEDURE demo2
 LOCAL locollection, lnindice
 
 * mme chose que demo1 mais on utilise une collection avec clefs
 locollection = CREATEOBJECT("collection")
 * je met des clefs dans le dsordre 
 locollection.add(1, "5")
 locollection.add(2, "8")
 locollection.add(3, "3")
 locollection.add(4, "2")
 locollection.keysort = 0 && index ascendant
 ? "index ordre ascendant"
 FOR EACH value IN locollection
   ? value
 NEXT
 locollection.keysort = 2 && clef ascendant
 ? "clef ordre ascendant"
 FOR EACH value IN locollection
   ? value
 NEXT
 ? "avec l'indice"
 FOR m.lnindice = 1 TO m.locollection.count
  ? TRANSFORM( m.locollection( m.lnindice))
 NEXT
 ? "on supprime le 3me lment et on reimprime "
 locollection.remove(3)
 locollection.keysort = 0 && index ascendant
 FOR EACH value IN locollection
   ? value
 NEXT
 ? "on insre un lment avant celui de clef '8' et on imprime"
 ? "(et pour corser un peu l'lment ajout est un texte)"
 locollection.add("  texte", "99", "8")
 locollection.keysort = 0 && index ascendant
 ? "index ordre ascendant"
 FOR EACH value IN locollection
   ? value
 NEXT
 locollection.keysort = 2 && clef ascendant
 ? "clef ordre ascendant"
 FOR EACH value IN locollection
   ? value
 NEXT
 ? "avec l'indice"
 FOR m.lnindice = 1 TO m.locollection.count
  ? TRANSFORM( m.locollection( m.lnindice))
 NEXT
ENDPROC && demo2

PROCEDURE demo_tarif
  LOCAL lotarif
  * on suppose que l'on doit facturer des repas  des clients
  * d'une cantine selon 2 tarifs diffrents le 'A' pour les
  * habitus et le 'B' pour les occasionnels
  lotarif = CREATEOBJECT("collection")
  * bien sr on pourrait mettre  jour la collection  partir 
  * d'une table
  lotarif.add( 5.5, "A") && 550 le repas pour les habitus
  lotarif.add( 6.2, "B") && 6.20 pour les occasionnels
  * on cre un curseur de clients alatoires
  CREATE CURSOR clients( nom C(30), tarif C(1), nombre N(3,0))
  INSERT INTO clients VALUES ("MAURICE", "A", 1)
  INSERT INTO clients VALUES ("CHENAVIER", "B", 1)
  INSERT INTO clients VALUES ("LEVY", "A", 10)
  INSERT INTO clients VALUES ("NIVELET", "B", 10)
  INSERT INTO clients VALUES ("LEPAGE", "A", 22)  && c'est un gros mangeur !
  SCAN ALL
    ? clients.nom+ STR(clients.nombre,3)+"*"+ ;
     TRANSFORM(m.lotarif( clients.tarif), "99.99") + "=" +;
     TRANSFORM(clients.nombre * m.lotarif( clients.tarif), "9999.99")+ ""
    * Vous ne trouvez pas que c'est vachement simple ?
  ENDSCAN
  USE
ENDPROC && demo_tarif

PROCEDURE demo_tarif_2
  LOCAL lotarif
  * mme problme que ci-dessus sauf que chaque tarif contient 
  * 3 valeurs : une pour les repas normaux, l'autre pour les
  * repas exceptionnels et la troisime pour les absences
  lotarif = CREATEOBJECT("collection")
  * bien sr on pourrait mettre  jour les collections  partir 
  * d'une table
  * notez bien que l'on peut utiliser un createobject comme
  * paramtre de la mthode add
  lotarif.add( CREATEOBJECT("collection"), "A")
  lotarif("A").add(5.5, "N")
  lotarif("A").add(7, "E")
  lotarif("A").add(5, "A")
  lotarif.add( CREATEOBJECT("collection"), "B")
  lotarif("B").add(6.2, "N")
  lotarif("B").add(8, "E")
  lotarif("B").add(6, "A")
  * on pourrait utiliser WITH ....
  * on cre un curseur de clients alatoires
  CREATE CURSOR cl( nom C(30), tarif C(1), normaux N(3,0), ;
    abscence N(3,0), Exception N(3,0))
  INSERT INTO cl VALUES ("MAURICE", "A", 1, 0, 0)
  INSERT INTO cl VALUES ("CHENAVIER", "B", 1, 1, 1)
  INSERT INTO cl VALUES ("LEVY", "A", 10, 2, 2)
  INSERT INTO cl VALUES ("NIVELET", "B", 10, 0, 1)
  INSERT INTO cl VALUES ("LEPAGE", "A", 22, 0, 0)
  SCAN ALL
    ? cl.nom+ STR(cl.normaux,3)+"*"+ ;
     TRANSFORM(m.lotarif( cl.tarif).item("N"), "99.99") + "+" +;
     STR(cl.abscence,3)+"*"+ ;
      TRANSFORM(m.lotarif( cl.tarif).item("A"), "99.99")+ ;
     "+" + STR(cl.exception,3)+"*"+ ;
      TRANSFORM(m.lotarif( cl.tarif).item("E"), "99.99")+ ;
     " = "+ TRANSFORM(cl.normaux * m.lotarif( cl.tarif).item("N")+ ;
      cl.abscence*m.lotarif( cl.tarif).item("A")+ ;
      cl.exception * m.lotarif( cl.tarif).item("E"), "9999.99")+ ""
    * Vous ne trouvez pas que c'est vachement simple ?
  ENDSCAN
  USE
ENDPROC && demo_tarif